<template>
  <div class="productdetail__info">
    <div class="title_pc">
      <h1 class="title-product mb10" itemprop="name">{{ product.name }}</h1>
      <div class="code">SKU: {{ product.sku }}</div>
      <meta itemprop="sku" :content="product.sku" />
      <div class="vote flex">
        <span>{{ rateaverage || 0 }}</span>
        <ul>
          <li
            v-for="star in 5"
            :key="'star' + star"
            :class="Math.round(rateaverage) >= star ? 'active' : ''"
          >
            <a v-if="Math.round(rateaverage) >= star" href="javascript:;">
              <svg-icon
                name="star-full"
                class="inline-block align-middle"
              ></svg-icon>
            </a>
            <a v-else href="javascript:;">
              <svg-icon
                name="star-none"
                class="inline-block align-middle"
              ></svg-icon>
            </a>
          </li>
        </ul>

        <a class="line" href="#box-vote">{{ ratetotal }} đánh giá</a>
        <a class="line" href="#box-comment">{{ meta.total }} bình luận</a>
      </div>
    </div>
    <div class="flex flex_2">
      <div class="description">
        <div
          class="thuong-hieu"
          itemprop="brand"
          itemtype="http://schema.org/Brand"
          itemscope
        >
          Thương hiệu:
          <nuxt-link :to="'/thuong-hieu/' + product.brand.shared_url">
            <img
              v-if="product.brand.icon != ''"
              :src="baseImageUrl + product.brand.icon"
              :alt="product.brand.name"
            />
          </nuxt-link>
          <meta itemprop="name" :content="product.brand.name" />
        </div>
        <!-- eslint-disable-next-line vue/no-v-html -->
        <div v-html="product.features"></div>
        <!-- <a href="javascript:;" class="view-more onclick-togle hover-a">
          Xem chi tiết
          <svg class="icon-svg">
            <use xlink:href="/images/icons/icon.svg#arrow-right" />
          </svg>
        </a> -->
        <div class="changer_color">
          <div>
            <strong>Màu sắc:</strong>
            {{ product.color }}
          </div>
          <ul>
            <li
              v-for="(color, index) in product.colors"
              :key="'color' + index"
              :class="index === 0 ? 'active' : ''"
            >
              <a href="javascript:;">
                <img
                  v-if="color.thumbnail != '/'"
                  :src="resizeImage(baseImageUrl + color.thumbnail, 50, 50)"
                />
                <img v-else src="/images/placeholder/placeholder-small.svg" />
              </a>
            </li>
          </ul>
        </div>
      </div>
      <div class="service border radius">
        <h2 class="lable-title">Bảo hành</h2>
        <!-- eslint-disable-next-line vue/no-v-html -->
        <div v-html="product.guarantee"></div>
        <template v-if="product.promotion">
          <hr />
          <h2 class="lable-title">Dịch vụ miễn phí</h2>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <div v-html="product.promotion"></div>
        </template>
      </div>
    </div>
    <template v-if="product.sale.remaining">
      <hr />
      <div class="tr qua-tang">
        <div class="flex flex_coutdown">
          <div class="flex_coutdown__text">
            <h2 class="lable-title">Khuyến mãi</h2>
            <p>
              <svg class="icon-svg">
                <use xlink:href="/images/icons/icon.svg#gift1" />
              </svg>
              Trừ
              <strong class="red">
                {{ product.sale.sale_money | formatNumber }}
              </strong>
              vào giá bán
            </p>
            <p
              v-for="(gift, index) in product.sale.sale_products"
              :key="'gift' + index"
            >
              <svg class="icon-svg">
                <use xlink:href="/images/icons/icon.svg#gift1" />
              </svg>
              Tặng {{ gift.name }} trị giá
              <strong class="red">{{ gift.price | formatNumber }}</strong>
            </p>
          </div>
          <div class="box_count">
            <label>Còn lại</label>
            <div id="countdown">{{ product.sale.remaining }} ngày</div>
          </div>
        </div>
      </div>
      <hr />
    </template>
    <!-- <hr />
    <div class="tr qua-tang">
      <h2 class="lable-title">Quà tặng cho sản phẩm</h2>
      <p>
        <svg class="icon-svg">
          <use xlink:href="../../../assets/images/icons/icon.svg#gift1" />
        </svg>
        Trừ
        <strong class="red">2.000.000đ</strong> vào giá bán
      </p>
      <p>
        <svg class="icon-svg">
          <use xlink:href="../../../assets/images/icons/icon.svg#gift1" />
        </svg>
        Nhận quà tặng lên đến
        <strong class="red">2.000.000đ</strong>
      </p>
      <p>
        <svg class="icon-svg">
          <use xlink:href="../../../assets/images/icons/icon.svg#gift1" />
        </svg>
        Tặng chuột ABC trị giá
        <strong class="red">2.000.000đ</strong>
      </p>
    </div> -->

    <div class="tr cau_hinh">
      <h2 class="lable-title">
        Có {{ product.options.length }} cấu hình tùy chọn
      </h2>
      <label
        v-for="(option, index) in product.options"
        :key="'option' + index"
        class="check-list border radius"
        :class="{ checked: selectedOption === option.sku }"
      >
        <div class="row">
          <div class="col-xs-8">
            <div class="flex mb8">
              <label class="txt_12">SKU: {{ option.sku }}</label>
              <span
                v-for="trangthai in option.trangthaihang"
                :key="trangthai.id"
                class="status txt_12 bg-oranger"
                :class="{ 'bg-green': trangthai.notes == '' }"
              >
                {{ trangthai.content }}
              </span>
              <span v-if="option.sale" class="status txt_12 bg-red">
                -{{ option.sale }}
              </span>
            </div>
            <!-- eslint-disable-next-line vue/no-v-html -->
            <div v-html="option.name"></div>
            <div>
              <div class="tp-tooltip-box">
                <span>
                  Hàng {{ option.tinh_trang }},
                  {{ option.nguon_hang | textNguonhang }}
                  <svg-icon name="info"></svg-icon>
                </span>
                <span class="tp-tooltip top center">
                  {{
                    getinfoSp(
                      option.tinh_trang,
                      option.nguon_hang,
                      product.brand.name
                    )
                  }}
                </span>
              </div>
            </div>
          </div>
          <div v-if="option.sale_price" class="col-xs-4 price tag">
            {{ option.sale_price | formatNumber }}
          </div>
          <div v-else class="col-xs-4 price tag">
            {{ option.price | formatNumber }}
          </div>
        </div>
        <input
          v-model="selectedOption"
          type="radio"
          :value="option.sku"
          @change="
            getProduct(product.shared_url, option.sku)
            updateParam(option.sku)
          "
        />
        <span class="checkmark"></span>
      </label>
    </div>
  </div>
</template>

<script>
import Helper from '../../../assets/config'

export default {
  name: 'ProductDetailInfo',
  // eslint-disable-next-line vue/require-prop-types
  props: ['product', 'getProduct', 'rateaverage', 'ratetotal', 'meta'],
  data() {
    return {
      selectedOption: '',
    }
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  mounted() {
    this.selectedOption = this.$route.query.option
  },
  methods: {
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    updateParam(option) {
      this.$router.push({ path: this.$route.path, query: { option } })
    },
    getinfoSp(tt, nh, brand) {
      let textStatus = ''
      if (tt === 'Used')
        return (textStatus =
          'Hàng qua sử dụng, nhập lại từ người dùng. Đã được kiểm định chất lượng bởi đội ngũ kỹ thuật của ThinkPro.')
      switch (tt) {
        case 'New Sealed':
          textStatus =
            textStatus +
            'Hàng nguyên niêm phong của nhà sản xuất, chưa mở. Tình trạng mới 100%. '
          break
        case 'New, Fullbox':
          textStatus =
            textStatus +
            'Hàng nguyên thùng của nhà sản xuất, được mở seal hộp để kiểm trang hàng hóa hải quan hoặc dán tem niêm phong của nhà bán lẻ, phân phối. '
          break
        case 'New, Outlet':
          textStatus =
            textStatus +
            'Hàng giảm giá của nhà sản xuất do tồn kho lâu hoặc các đơn hàng bị hủy, trả bởi khách hàng, tình trạng mới 100% chưa qua sử dụng. '
          break
        default:
          textStatus =
            textStatus +
            'Hàng qua sử dụng, nhập lại từ người dùng. Đã được kiểm định chất lượng bởi đội ngũ kỹ thuật của ThinkPro.'
      }
      switch (nh) {
        case 'Hàng chính hãng':
          textStatus = textStatus + 'Phân phối chính hãng bởi ' + brand
          break
        default:
          textStatus = textStatus + 'Phân phối bởi ThinkPro.'
      }
      return textStatus
    },
  },
}
</script>
